/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumIsocode;
import de.ship.db.enums.EnumTransCategory;
import de.ship.db.tables.records.VCoreTranslationRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreTranslation extends TableImpl<VCoreTranslationRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_translation</code>
     */
    public static final VCoreTranslation V_CORE_TRANSLATION = new VCoreTranslation();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreTranslationRecord> getRecordType() {
        return VCoreTranslationRecord.class;
    }

    /**
     * The column
     * <code>common_dd.v_core_translation.pk_core_translationkey</code>.
     */
    public final TableField<VCoreTranslationRecord, Integer> PK_CORE_TRANSLATIONKEY = createField(DSL.name("pk_core_translationkey"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_translation.pk_core_translation</code>.
     */
    public final TableField<VCoreTranslationRecord, Integer> PK_CORE_TRANSLATION = createField(DSL.name("pk_core_translation"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_translation.fk_trans_key</code>.
     */
    public final TableField<VCoreTranslationRecord, String> FK_TRANS_KEY = createField(DSL.name("fk_trans_key"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_translation.isocode</code>.
     */
    public final TableField<VCoreTranslationRecord, EnumIsocode> ISOCODE = createField(DSL.name("isocode"), SQLDataType.VARCHAR.asEnumDataType(EnumIsocode.class), this, "");

    /**
     * The column <code>common_dd.v_core_translation.category</code>.
     */
    public final TableField<VCoreTranslationRecord, EnumTransCategory> CATEGORY = createField(DSL.name("category"), SQLDataType.VARCHAR.asEnumDataType(EnumTransCategory.class), this, "");

    /**
     * The column <code>common_dd.v_core_translation.value</code>.
     */
    public final TableField<VCoreTranslationRecord, String> VALUE = createField(DSL.name("value"), SQLDataType.CLOB, this, "");

    private VCoreTranslation(Name alias, Table<VCoreTranslationRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreTranslation(Name alias, Table<VCoreTranslationRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_translation" as  SELECT l.pk AS pk_core_translationkey,
         t.pk AS pk_core_translation,
         t.fk_trans_key,
         t.isocode,
         t.category,
         t.value
        FROM (common_dd.t_core_translation_key l
          LEFT JOIN common_dd.t_core_translation t ON ((l.translation_key = t.fk_trans_key)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_translation</code> table
     * reference
     */
    public VCoreTranslation(String alias) {
        this(DSL.name(alias), V_CORE_TRANSLATION);
    }

    /**
     * Create an aliased <code>common_dd.v_core_translation</code> table
     * reference
     */
    public VCoreTranslation(Name alias) {
        this(alias, V_CORE_TRANSLATION);
    }

    /**
     * Create a <code>common_dd.v_core_translation</code> table reference
     */
    public VCoreTranslation() {
        this(DSL.name("v_core_translation"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreTranslation as(String alias) {
        return new VCoreTranslation(DSL.name(alias), this);
    }

    @Override
    public VCoreTranslation as(Name alias) {
        return new VCoreTranslation(alias, this);
    }

    @Override
    public VCoreTranslation as(Table<?> alias) {
        return new VCoreTranslation(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreTranslation rename(String name) {
        return new VCoreTranslation(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreTranslation rename(Name name) {
        return new VCoreTranslation(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreTranslation rename(Table<?> name) {
        return new VCoreTranslation(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslation where(Condition condition) {
        return new VCoreTranslation(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslation where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslation where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslation where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreTranslation where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreTranslation where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreTranslation where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreTranslation where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslation whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreTranslation whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
